/**
 * @author Hamid Ebadi
 *
 */
public class Calculator2 {
	// operators 
	private enum CalcOperator {
		PLUS, MINUS , MULTIPLY , DIVISION , EQUAL,  UNDEFINED;
	}
	// Calculate State 
	private CalcOperator CSoperator ;
	private Integer CSoperand  ;
	private Boolean CSValidBuffer ;   
	private String CSbuffer  ;
	private Boolean InBracket ;
	private Calculator2 BracketCalc ;
	// Methods
	// Constructor 
	Calculator2 (){
		pressReset();
	}
	public Boolean CheckInBracket(){
		return InBracket;
	}
	public void pressReset(){
		CSbuffer = "" ;
		CSoperand = 0 ;
		CSoperator= CalcOperator.UNDEFINED ;
		CSValidBuffer = false;
		InBracket= false;
	}
	
	public void pressOpenBracket(){
		if(InBracket) {
			BracketCalc.pressOpenBracket();
		} else {
			InBracket = true ;
			BracketCalc = new Calculator2();
		}
	}
	public void pressCloseBracket(){
		if (InBracket){
			if(BracketCalc.CheckInBracket()) {
				BracketCalc.pressCloseBracket();
			} else {
				InBracket = false ;
				BracketCalc.pressEqual();
				Integer tmp = BracketCalc.getOperand();
				CSbuffer = tmp.toString() ;
				CSValidBuffer= true ;
				pressEqual();
			}
		}else {
			System.out.println("Unbalanced brackets (Close bracket)");
		}
	}
	public void pressDigit(char digit){
		if(InBracket) {
			BracketCalc.pressDigit(digit);
		} else {
			if (!Character.isDigit(digit)){
				System.out.println("Invalid digit" );
			}else {		  
				if (CSValidBuffer){
					CSbuffer  = CSbuffer + digit ;
				}else {
					CSbuffer = String.valueOf(digit);
					CSValidBuffer = true ;
				}
			}
		}

	}
	public void pressPlus(){
		if(InBracket) {
			BracketCalc.pressPlus();
		} else {
			pressOp(CalcOperator.PLUS);
		}
	}
	public void pressMinus(){
		if(InBracket) {
			BracketCalc.pressMinus();
		} else {
			pressOp(CalcOperator.MINUS);
		}
	}
	public void pressMult(){
		if(InBracket) {
			BracketCalc.pressMult();
		} else {
			pressOp(CalcOperator.MULTIPLY);
		}
	}
	public void pressDiv(){
		if(InBracket) {
			BracketCalc.pressDiv();
		} else {
			pressOp(CalcOperator.DIVISION);
		}
	}
	public void pressEqual(){
		if(InBracket) {
			BracketCalc.pressEqual();
		} else {
			pressOp(CalcOperator.EQUAL);
		}
	}
	public String getBuffer(){
		return CSbuffer;	
	}
	public int getOperand() {
		return CSoperand;
	}
	private void setOperand(Integer value){
		CSoperand = value ;		
	}
	private Integer BufferToInteger(){
		if (CSbuffer.length()<4){
			return Integer.valueOf(CSbuffer);
		}else {
			System.out.println("too long digit");
			return 0; 
		}
	}
	private void pressOp(CalcOperator op) {
	
		if (CSValidBuffer ) // we read the number but we have not read the operator yet 
		{
			if (CSoperator == CalcOperator.PLUS) setOperand(  getOperand() + BufferToInteger());
			if (CSoperator == CalcOperator.MINUS) setOperand( getOperand() - BufferToInteger());
			if (CSoperator == CalcOperator.DIVISION) {
				Integer divisor = BufferToInteger() ;
				if (divisor == 0 ){
					System.out.println("Division by zero" ); 
					// Now you can either
						// 1)choose an operator followed by a new operand or 
						// 2) a new operand that can be used as divisor
				} else {
					setOperand( getOperand() / divisor );
				}
			}
			if (CSoperator == CalcOperator.MULTIPLY) setOperand( getOperand() *BufferToInteger());
			if (CSoperator == CalcOperator.EQUAL) setOperand( BufferToInteger());
			if (CSoperator == CalcOperator.UNDEFINED) setOperand( BufferToInteger());
		}
		CSoperator  = op ;
		CSValidBuffer = false ;
	}
	public static void main(String[] args) {
		Calculator2 calc= new Calculator2();
		if (args.length < 1) System.out.println("Missing command-line arguments. ( e.g. 1+3 -4= )\n " );
		for (int i = 0 ; i!= args.length ; i++) {
			for (int j = 0 ; j!= args[i].length() ; j++) {
				char ch = args[i].charAt(j) ;
				if (Character.isDigit(ch)){
					calc.pressDigit(ch);
				}
				switch(ch){
				case '+' :
					calc.pressPlus();
					break;
				case '-' :
					calc.pressMinus();
					break;
				case '/':
					calc.pressDiv();
					break;
				case '*':
					calc.pressMult();
					break;
				case '=':
					calc.pressEqual();
					break;
				case '(':
					calc.pressOpenBracket();
					break;
				case ')':
					calc.pressCloseBracket();
					break;	
				default :
					
				}
				System.out.println("Result of proccessing \"" + ch + "\" :  Operand(Memory) :" + calc.getOperand()+ ",   Digit buffer :" + calc.getBuffer());
			}
		}

	}

}